#import "Bullet.h"

//Bulletの実装
@implementation Bullet

//プロパティの実装
@synthesize pos=_pos;

//イメージの取得
- (UIImage*)loadImage:(NSString*)name {
    if (_screenScale==1.0f) return [UIImage imageNamed:name];
    return [UIImage imageNamed:[NSString stringWithFormat:@"%@_L%@",
        [name substringToIndex:name.length-4],
        [name substringFromIndex:name.length-4]]];
}

//弾の初期化
- (id)init_parent:(UIView*)parent  
    screenScale:(float)screenScale pos:(CGPoint)pos {
    if (self=[super init]) {
        _screenScale=screenScale;
        
        //イメージビューの生成
        _view=[[UIImageView alloc] init];
        [_view setFrame:CGRectMake(0,0,30*_screenScale,30*_screenScale)];
        [_view setImage:[self loadImage:@"bullet.png"]];        
        [parent addSubview:_view];        
        
        //変数の初期化
        _pos =pos;
        _v   =CGPointMake(-2*_screenScale,-1*_screenScale);
        if (_pos.x<240*_screenScale) _v.x=-_v.x;
        if (_pos.x<160*_screenScale) _v.y=-_v.y;
        _scale=1.0f;
    }
    return self;
}

//メモリ解放
-(void)dealloc {
    [_view removeFromSuperview];
    [_view release];
    [super dealloc];
}

//弾の移動
- (BOOL)move {
    //移動
    if (_scale<0.2f) return NO;
    _pos.x+=_v.x;
    _pos.y+=_v.y;
    _scale-=_scale/10;
    CGAffineTransform trans=CGAffineTransformMakeTranslation(
        _pos.x-30*_screenScale,_pos.y-30*_screenScale);
    _view.transform=CGAffineTransformScale(trans,_scale,_scale);
    return YES;
}
@end
