#import "TwitterClient.h"
#import "SA_OAuthTwitterEngine.h"

//コンシューマーキーとコンシューマーシークレット
#define kOAuthConsumerKey    @"コンシューマーキーを記述"
#define kOAuthConsumerSecret @"コンシューマーシークレットを記述"

//TwitterClientの実装
@implementation TwitterClient

//====================
//ユーティリティ
//====================
//アラートの表示
- (void)showAlert:(NSString*)title text:(NSString*)text {
    UIAlertView* alert=[[[UIAlertView alloc] 
        initWithTitle:title message:text delegate:nil 
        cancelButtonTitle:@"OK" otherButtonTitles:nil] autorelease];
    [alert show];
}

//入力ダイアログの表示
- (void)showInputDialog {
    [_tfComment setText:@""];
    UIAlertView* alert=[[[UIAlertView alloc] 
        initWithTitle:@"" message:@"つぶやきを入力\n\n\n"
        delegate:self cancelButtonTitle:@"Cancel" 
        otherButtonTitles:@"Send",nil] autorelease];
    [alert addSubview:_tfComment];
    [alert setDelegate:self];
    [alert show];
    [_tfComment becomeFirstResponder];
}

//インジケーターの指定
- (void)setIndicator:(BOOL)indicator {
    [UIApplication sharedApplication].
        networkActivityIndicatorVisible=indicator;
}

//テキストボタンの生成
- (UIButton*)makeButton:(CGRect)rect text:(NSString*)text tag:(int)tag {
    UIButton* button=[UIButton buttonWithType:UIButtonTypeRoundedRect];
    [button setTitle:text forState:UIControlStateNormal];
    [button setFrame:rect];
    [button setTag:tag];
    return button;
}

//ラベルの生成
- (UILabel*)makeLabel:(CGRect)rect text:(NSString*)text font:(UIFont*)font {
    UILabel* label=[[[UILabel alloc] init] autorelease];         
    [label setFrame:rect];    
    [label setText:text];
    [label setFont:font];
    [label setTextColor:[UIColor blackColor]];
    [label setBackgroundColor:[UIColor clearColor]];
    [label setTextAlignment:UITextAlignmentLeft];
    [label setNumberOfLines:0];
    [label setLineBreakMode:UILineBreakModeWordWrap];
    return label;
}

//テキストフィールドの生成
- (UITextField*)makeTextField:(CGRect)rect {
    UITextField* textField=[[[UITextField alloc] init] autorelease];
    [textField setFrame:rect];
    [textField setReturnKeyType:UIReturnKeyDone];
    [textField setBorderStyle:UITextBorderStyleRoundedRect];
    return textField;
}

//イメージビューの生成
- (UIImageView*)makeImageView:(CGRect)rect image:(UIImage*)image {
    UIImageView* imageView=[[[UIImageView alloc] init] autorelease];
    [imageView setImage:image];
    [imageView setFrame:rect];
    return imageView;
}

//====================
//アイコンの読み込み
//====================
//アイコンの読み込み
- (void)loadIcon:(int)idx {
    _itemsIdx=idx;

    //アイコンの読み込み完了
    if (_itemsIdx>=_items.count) {
        [self setIndicator:NO];
        [_tableView reloadData];
        return;
    }
    
    //読み込み済みアイコンの取得
    Status* status=[_items objectAtIndex:_itemsIdx];    
    for (int i=0;i<_items.count;i++) {
        Status* s=[_items objectAtIndex:i];
        if (s.icon!=nil && [s.iconURL isEqualToString:status.iconURL]) {
            status.icon=s.icon;
            [self loadIcon:_itemsIdx+1];
            return;
        }
    }    

    //アイコンの通信読み込み
    NSURLRequest* request=[NSURLRequest 
        requestWithURL:[NSURL URLWithString:status.iconURL]
        cachePolicy:NSURLRequestUseProtocolCachePolicy 
        timeoutInterval:30.0];        
    [NSURLConnection connectionWithRequest:request delegate:self];
}

//データ受信開始時に呼ばれる
- (void)connection:(NSURLConnection*)connection
    didReceiveResponse:(NSURLResponse*)response {
    if (_data!=nil) [_data release];
    _data=[[NSMutableData data] retain];
}

//データ受信時に呼ばれる
- (void)connection:(NSURLConnection*)connection
    didReceiveData:(NSData*)data {
    [_data appendData:data];
}

//データ受信完了時に呼ばれる
- (void)connectionDidFinishLoading:(NSURLConnection*)connection {
    UIImage* icon=[[[UIImage alloc] initWithData:_data] autorelease];
    Status* status=[_items objectAtIndex:_itemsIdx];    
    status.icon=icon;
    [_data release];
    _data=nil;
    [self loadIcon:_itemsIdx+1];
}

//データ受信失敗時に呼ばれる
- (void)connection:(NSURLConnection*)connection 
    didFailWithError:(NSError*)error {
    [self setIndicator:NO];
    [self showAlert:@"" text:@"通信失敗しました"];
}

//====================
//Twitterのリクエスト
//====================
//タイムラインの取得(6)
- (void)timeline {
    if (![_engine isAuthorized]) {//(5)
        [self login];
        return;
    }
    [self setIndicator:YES];
    [_items removeAllObjects];
    [_engine getFollowedTimelineSinceID:0 startingAtPage:0 count:20];
}

// タイムラインの取得の成功時に呼ばれる(6)
- (void)statusesReceived:(NSArray*)statuses 
    forRequest:(NSString*)connectionIdentifier {
    for (int i=0;i<statuses.count;i++) {
        Status* item=[[[Status alloc] init] autorelease];
        NSDictionary* status=[statuses objectAtIndex:i];
        item.text   =[status objectForKey:@"text"];
        NSDictionary* user  =[status objectForKey:@"user"];
        item.name   =[user objectForKey:@"screen_name"];
        item.iconURL=[user objectForKey:@"profile_image_url"];
        [_items addObject:item];
    }
    [self loadIcon:0];
}

//リクエスト成功時に呼ばれる(6)
- (void)requestSucceeded:(NSString*)requestIdentifier {
    [self setIndicator:NO];
}

//リクエスト失敗時に呼ばれる(6)
- (void)requestFailed:(NSString*)requestIdentifier withError:(NSError*)error {
    [self setIndicator:NO];
    [self showAlert:@"" text:@"通信失敗しました"];
}


//つぶやき(7)
- (void)twit:(NSString*)text {
    if (![_engine isAuthorized]) {//(5)
        [self login];
        return;
    }
    [self setIndicator:YES];
    [_engine sendUpdate:text];
}


//====================
//Twitterのログイン
//====================
//Twitterのログイン
- (void)login {
    //Twitterエンジンの生成(1)
    if (_engine!=nil) [_engine release];
    _engine=[[SA_OAuthTwitterEngine alloc] initOAuthWithDelegate:self];
    _engine.consumerKey   =kOAuthConsumerKey;
    _engine.consumerSecret=kOAuthConsumerSecret;
    
    //Twitterコントローラの生成(3)
    UIViewController* oauthCtl=[SA_OAuthTwitterController 
        controllerToEnterCredentialsWithTwitterEngine:_engine delegate:self];
    if (oauthCtl==nil) {
        //タイムラインの取得(初回)
        if (_items.count==0) [self timeline];
        return;
    }
    [self presentModalViewController:oauthCtl animated:YES]; 
}

//認証データの保存時に呼ばれる(2)
- (void)storeCachedTwitterOAuthData:(NSString*)data 
    forUsername:(NSString*)username {
    NSUserDefaults* pref=[NSUserDefaults standardUserDefaults];
    [pref setObject:data forKey:@"authData"];
    [pref synchronize];
}

//認証データの取得時に呼ばれる(2)
- (NSString*)cachedTwitterOAuthDataForUsername:(NSString*)username {
    if (_setup) return nil;
    return [[NSUserDefaults standardUserDefaults] objectForKey:@"authData"];
}

//ログイン成功時に呼ばれる(4)
- (void)OAuthTwitterController:(SA_OAuthTwitterController*) 
    controller authenticatedWithUsername:(NSString*)username {
    [self dismissModalViewControllerAnimated:YES];
    
    //タイムラインの取得(初回)
    [self timeline];
}

//ログイン失敗時に呼ばれる(4)
- (void)OAuthTwitterControllerFailed:(SA_OAuthTwitterController*)controller {
    [self dismissModalViewControllerAnimated:YES];
    [self showAlert:@"" text:@"認証失敗しました"];
}

//ログインキャンセル時に呼ばれる(4)
- (void)OAuthTwitterControllerCanceled:(SA_OAuthTwitterController*)controller {
    [self dismissModalViewControllerAnimated:YES];
}

//====================
//初期化
//====================
//初期化
- (void)viewDidLoad {
    [super viewDidLoad];
    
    //UI
    self.title=@"Twitterクライアント";    
    _tfComment=[[self makeTextField:CGRectMake(12,50,260,25)] retain]; 
    [_tfComment setDelegate:self];
    _portrait=NO;
    
    //変数
    _engine  =nil;
    _setup   =NO;
    _data    =nil;
    _items   =[[NSMutableArray array] retain];
    _itemsIdx=0;
        
    //ログイン
    [self login];
}

//メモリ解放
- (void)dealloc {
    [_tableView release];
    [_tfComment release];
    [_engine release];
    [_data release];
    [_items release];
    [super dealloc];
}


//====================
//UIのデリゲート
//====================
//ツールバーボタンクリック時のイベント処理
- (IBAction)action:(UIBarButtonItem*)sender {
    if (sender.tag==0) {
        [self timeline];
    } else if (sender.tag==1) {
        [self showInputDialog];
    } else if (sender.tag==2) {
        _setup=YES;
        [self login];
    }
}

//行数の取得
- (NSInteger)tableView:(UITableView*)tableView 
    numberOfRowsInSection:(NSInteger)section {
    return _items.count;
}

//行の高さの取得
- (CGFloat)tableView:(UITableView*)tableView 
    heightForRowAtIndexPath:(NSIndexPath*)indexPath {
    Status* status=[_items objectAtIndex:indexPath.row];
    float w=(_portrait)?
        self.view.window.screen.bounds.size.width-70:
        self.view.window.screen.bounds.size.height-70;
    CGSize size=[status.text sizeWithFont:[UIFont systemFontOfSize:14] 
        constrainedToSize:CGSizeMake(w,1024)
        lineBreakMode:UILineBreakModeCharacterWrap];
    float height=30+size.height+10;
    return (height<60)?60:height;
}

//行のセルの取得
- (UITableViewCell*)tableView:(UITableView*)tableView 
    cellForRowAtIndexPath:(NSIndexPath*)indexPath {
    //テーブルのセルの生成
    UITableViewCell* cell=[[[UITableViewCell alloc] 
        initWithStyle:UITableViewCellStyleSubtitle 
        reuseIdentifier:@"table_cell"] autorelease];
    [cell setSelectionStyle:UITableViewCellSelectionStyleNone];
    if (_items.count<=indexPath.row) return cell;

    //セルの編集
    Status* status=[_items objectAtIndex:indexPath.row];
    UIImageView* imgIcon=[self makeImageView:
        CGRectMake(10,10,40,40) image:status.icon];
    [cell.contentView addSubview:imgIcon];
    UILabel* lblName=[self makeLabel:CGRectMake(60,10,250,16) 
        text:status.name font:[UIFont boldSystemFontOfSize:16]];
    [cell.contentView addSubview:lblName];
    float w=(_portrait)?
        self.view.window.screen.bounds.size.width-70:
        self.view.window.screen.bounds.size.height-70;
    CGSize size=[status.text sizeWithFont:[UIFont systemFontOfSize:14] 
        constrainedToSize:CGSizeMake(w,1024)
        lineBreakMode:UILineBreakModeCharacterWrap];
    UILabel* lblText=[self makeLabel:CGRectMake(60,30,w,size.height) 
        text:status.text font:[UIFont systemFontOfSize:14]];
    [cell.contentView addSubview:lblText];
    return cell;
}

//テキストフィールドリターンのイベント処理
- (BOOL)textFieldShouldReturn:(UITextField*)sender {
    [sender resignFirstResponder];
    return YES;
}

//テキストフィールドの文字変更のイベント処理
- (BOOL)textField:(UITextField*)textField 
    shouldChangeCharactersInRange:(NSRange)range 
    replacementString:(NSString*)string {
    if (string.length==0) return YES;
    return (textField.text.length+string.length<=140);
}

//入力ダイアログのボタンクリック後に呼ばれる
- (void)alertView:(UIAlertView*)alertView 
    clickedButtonAtIndex:(NSInteger)buttonIndex {
    if (buttonIndex==1) [self twit:_tfComment.text];
}

//画面を端末の向きにあわせて回転
- (BOOL)shouldAutorotateToInterfaceOrientation:
    (UIInterfaceOrientation)orientation {
    if (orientation==UIDeviceOrientationLandscapeLeft ||
        orientation==UIDeviceOrientationLandscapeRight) {
        _portrait=NO;
        [_tableView reloadData];
    } else if (orientation==UIDeviceOrientationPortraitUpsideDown ||
        orientation==UIDeviceOrientationPortrait) {
        _portrait=YES;
        [_tableView reloadData];
    } 
    return YES;
}
@end
